package dk.dtu.s094758.lib.credentials;

/**
 * Classification levels.
 *
 * @author linas
 */
public enum ClassificationLevel {

    /**
     * The highest level of classification.
     */
    LEVEL_4_TOP_SECRET(4),
    /**
     * Would cause grave damage if leaked.
     */
    LEVEL_3_SECRET(3),
    /**
     * Would cause damage if leaked.
     */
    LEVEL_2_CONFIDENTIAL(2),
    /**
     * Would cause undesirable effects if leaked.
     */
    LEVEL_1_RESTRICRED(1),
    /**
     * The lowest level of classification. Public information.
     */
    LEVEL_0_UNCLASSIFIED(0);

    private Integer numericValue;

    private ClassificationLevel(Integer numericValue) {
        this.numericValue = numericValue;
    }

    public int getNumericValue() {
        return numericValue;
    }
}
