package dk.dtu.s094758.company.companyservice;

import dk.dtu.s094758.company.companyservice.CompanyService_ExchangeProcessor;
import dk.dtu.s094758.company.companyservice.CompanyServiceImplementationManager;
import dk.dtu.s094758.company.companyservice.CompanyServiceTestImplementation;
import dk.dtu.s094758.company.companyservice.CompanyService_WSOUIService;
import javax.xml.ws.Endpoint;
import org.petalslink.easiestdemo.wsoui.provided.ProviderConfiguration;
import org.petalslink.easiestdemo.wsoui.provided.ProviderConfiguration.PositionType;
import org.petalslink.easiestdemo.wsoui.core.WSOUIException;
import org.petalslink.abslayer.service.api.Description;
import org.petalslink.easiestdemo.wsoui.provided.AbstractImplementationManager;

public class CompanyService_WSOUIServer {

	private Endpoint endpointFor_CompanyService = null;
	private ProviderConfiguration confEndpointFor_CompanyService = null;
	private AbstractImplementationManager<?> im = null;
	
	public CompanyService_WSOUIServer() {
	}


	public ProviderConfiguration createDefaultProviderConfigurationFor_CompanyService() {
		ProviderConfiguration conf = new ProviderConfiguration();
		conf.setEndpointAddress("http://localhost:8282/CompanyService/CompanyService");
		conf.setPosition(PositionType.NORTH_EAST);
		conf.setActiveGui(false);
		return conf;
	}


	public ProviderConfiguration getProviderConfigurationFor_CompanyService() {
		if(this.confEndpointFor_CompanyService == null) {
			this.confEndpointFor_CompanyService = createDefaultProviderConfigurationFor_CompanyService();
		}
		return this.confEndpointFor_CompanyService;
	}


	public void start() throws WSOUIException {
		confEndpointFor_CompanyService = getProviderConfigurationFor_CompanyService();
		im = new CompanyServiceImplementationManager(new CompanyServiceTestImplementation(new CompanyService_ExchangeProcessor()), CompanyService_WSOUIService.WSDL_LOCATION, confEndpointFor_CompanyService);
		endpointFor_CompanyService = Endpoint.publish(confEndpointFor_CompanyService.getEndpointAddress(), im);
		System.out.println("Service deploy at: " + confEndpointFor_CompanyService.getEndpointAddress() + "?wsdl");
		System.out.println("Service Configuration: " + confEndpointFor_CompanyService);
	}


	public void stop() {
		endpointFor_CompanyService.stop();
	}


	public Description getDescription() {
		return im.getDescription();
	}


	public static void main(String args[]) throws Exception {
		CompanyService_WSOUIServer provider = new CompanyService_WSOUIServer();
		provider.start();
		provider.getProviderConfigurationFor_CompanyService().setActiveGui(true);
		System.out.println("Server ready...");
	}

}
