package dk.dtu.s094758.postal.postalservice;

import dk.dtu.s094758.postal.postalservice.PostalService_ExchangeProcessor;
import dk.dtu.s094758.postal.postalservice.PostalServiceImplementationManager;
import dk.dtu.s094758.postal.postalservice.PostalServiceTestImplementation;
import dk.dtu.s094758.postal.postalservice.PostalService_WSOUIService;
import javax.xml.ws.Endpoint;
import org.petalslink.easiestdemo.wsoui.provided.ProviderConfiguration;
import org.petalslink.easiestdemo.wsoui.provided.ProviderConfiguration.PositionType;
import org.petalslink.easiestdemo.wsoui.core.WSOUIException;
import org.petalslink.abslayer.service.api.Description;
import org.petalslink.easiestdemo.wsoui.provided.AbstractImplementationManager;

public class PostalService_WSOUIServer {

	private Endpoint endpointFor_PostalService = null;
	private ProviderConfiguration confEndpointFor_PostalService = null;
	private AbstractImplementationManager<?> im = null;
	
	public PostalService_WSOUIServer() {
	}


	public ProviderConfiguration createDefaultProviderConfigurationFor_PostalService() {
		ProviderConfiguration conf = new ProviderConfiguration();
		conf.setEndpointAddress("http://localhost:8383/PostalService/PostalService");
		conf.setPosition(PositionType.NORTH_EAST);
		conf.setActiveGui(false);
		return conf;
	}


	public ProviderConfiguration getProviderConfigurationFor_PostalService() {
		if(this.confEndpointFor_PostalService == null) {
			this.confEndpointFor_PostalService = createDefaultProviderConfigurationFor_PostalService();
		}
		return this.confEndpointFor_PostalService;
	}


	public void start() throws WSOUIException {
		confEndpointFor_PostalService = getProviderConfigurationFor_PostalService();
		im = new PostalServiceImplementationManager(new PostalServiceTestImplementation(new PostalService_ExchangeProcessor()), PostalService_WSOUIService.WSDL_LOCATION, confEndpointFor_PostalService);
		endpointFor_PostalService = Endpoint.publish(confEndpointFor_PostalService.getEndpointAddress(), im);
		System.out.println("Service deploy at: " + confEndpointFor_PostalService.getEndpointAddress() + "?wsdl");
		System.out.println("Service Configuration: " + confEndpointFor_PostalService);
	}


	public void stop() {
		endpointFor_PostalService.stop();
	}


	public Description getDescription() {
		return im.getDescription();
	}


	public static void main(String args[]) throws Exception {
		PostalService_WSOUIServer provider = new PostalService_WSOUIServer();
		provider.start();
		provider.getProviderConfigurationFor_PostalService().setActiveGui(true);
		System.out.println("Server ready...");
	}

}
