package dk.dtu.s094758.generator;

import dk.dtu.s094758.company.companyservice.BuyProduct;
import dk.dtu.s094758.company.companyservice.BuyProductDocument;
import dk.dtu.s094758.company.companyservice.BuyProductResponse;
import dk.dtu.s094758.company.companyservice.Customer;
import dk.dtu.s094758.company.companyservice.Product;
import dk.dtu.s094758.company.companyservice.ValidateCustomer;
import dk.dtu.s094758.company.companyservice.ValidateCustomerDocument;
import dk.dtu.s094758.company.companyservice.ValidateCustomerResponse;
import dk.dtu.s094758.postal.postalservice.Address;
import dk.dtu.s094758.postal.postalservice.Person;
import dk.dtu.s094758.postal.postalservice.ValidateAddress;
import dk.dtu.s094758.postal.postalservice.ValidateAddressDocument;
import dk.dtu.s094758.postal.postalservice.ValidateAddressResponse;
import dk.dtu.s094758.shop.shopservice.Client;
import dk.dtu.s094758.shop.shopservice.Order;
import dk.dtu.s094758.shop.shopservice.Receipt;

/**
 * Hello world!
 *
 */
public class App {

    public static void main(String[] args) {

        // Postal Service

        String address = Generator.generateBeanClass(Address.class, Address.type);
        String person = Generator.generateBeanClass(Person.class, Person.type);

        String validateAddressMethod = Generator.generateServiceMethod(
                ValidateAddress.class, ValidateAddress.type,
                ValidateAddressDocument.class, ValidateAddressDocument.type,
                ValidateAddressResponse.class, ValidateAddressResponse.type);

        String postalService = Generator.generateServiceClass(
                "PostalService", ValidateAddress.class.getPackage().getName(),
                validateAddressMethod);

        System.out.println(address);
        System.out.println(person);
        System.out.println(postalService);

        // Company Service

        String customer = Generator.generateBeanClass(Customer.class, Customer.type);
        String product = Generator.generateBeanClass(Product.class, Product.type);

        String buyProductMethod = Generator.generateServiceMethod(
                BuyProduct.class, BuyProduct.type,
                BuyProductDocument.class, BuyProductDocument.type,
                BuyProductResponse.class, BuyProductResponse.type);

        String validateCustomerMethod = Generator.generateServiceMethod(
                ValidateCustomer.class, ValidateCustomer.type,
                ValidateCustomerDocument.class, ValidateCustomerDocument.type,
                ValidateCustomerResponse.class, ValidateCustomerResponse.type);

        String companyService = Generator.generateServiceClass(
                "CompanyService", ValidateCustomer.class.getPackage().getName(),
                buyProductMethod, validateCustomerMethod);

        System.out.println(customer);
        System.out.println(product);
        System.out.println(companyService);

        // Shop Service

        String client = Generator.generateBeanClass(Client.class, Client.type);
        String order = Generator.generateBeanClass(Order.class, Order.type);
        String receipt = Generator.generateBeanClass(Receipt.class, Receipt.type);

        System.out.println(client);
        System.out.println(order);
        System.out.println(receipt);
    }
}
