package dk.dtu.s094758.generator;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author linas
 */
public class BpelGenerator {

    private static Map<String, String[]> messageTypeToJavaTypeMap;

    public static void main(String argv[]) {

        File bpelFile = new File("./src/main/bpel/ShopBpelModule.bpel");
        DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();

        DocumentBuilder documentBuilder = null;
        try {
            documentBuilder = documentBuilderFactory.newDocumentBuilder();
        } catch (ParserConfigurationException ex) {
            Logger.getLogger(BpelGenerator.class.getName()).log(Level.SEVERE, null, ex);
        }

        Document document = null;
        try {
            document = documentBuilder.parse(bpelFile);
        } catch (SAXException ex) {
            Logger.getLogger(BpelGenerator.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(BpelGenerator.class.getName()).log(Level.SEVERE, null, ex);
        }

        document.getDocumentElement().normalize();




        NodeList variableList = document.getElementsByTagName("variable");

        for (int idx = 0; idx < variableList.getLength(); idx++) {

            Node variable = variableList.item(idx);

            if (variable.getNodeType() == Node.ELEMENT_NODE) {

                String messageType = variable.getAttributes().getNamedItem("messageType").getTextContent();
                String name = variable.getAttributes().getNamedItem("name").getTextContent();

                String[] javaTypes = messageTypeToJavaTypes(messageType);

                for (String javaType : javaTypes) {
                    System.out.println(javaType);
                }

//                NamedNodeMap attributes = variable.getAttributes();
//
//                for (int idx1 = 0; idx1 < attributes.getLength(); idx1++) {
//                    Node attribute = attributes.item(idx1);
//                    String attributeName = attribute.getNodeName();
//                    String attributeValue = attribute.getTextContent();
//
//                    System.out.println(attributeName + " " + attributeValue);
//                    System.out.println();
//                }
            }

        }
    }

    private static String[] messageTypeToJavaTypes(String messageType) {

        if (messageTypeToJavaTypeMap == null) {

            messageTypeToJavaTypeMap = new HashMap<String, String[]>();

            messageTypeToJavaTypeMap.put("tns:buyProductResponse", new String[]{"boolean"});
            messageTypeToJavaTypeMap.put("tns:buyProduct", new String[]{"dk.dtu.s094758.company.companyservice.Product"});
            messageTypeToJavaTypeMap.put("tns:validateAddressResponse", new String[]{"boolean"});
            messageTypeToJavaTypeMap.put("tns:validateAddress", new String[]{"dk.dtu.s094758.postal.postalservice.Address", "dk.dtu.s094758.postal.postalservice.Person"});
            messageTypeToJavaTypeMap.put("tns:validateCustomerResponse", new String[]{"boolean"});
            messageTypeToJavaTypeMap.put("tns:validateCustomer", new String[]{"dk.dtu.s094758.company.companyservice.Customer"});
            messageTypeToJavaTypeMap.put("tns:orderProductResponse", new String[]{"dk.dtu.s094758.shop.shopservice.Client", "dk.dtu.s094758.shop.shopservice.Order"});
            messageTypeToJavaTypeMap.put("tns:orderProduct", new String[]{"dk.dtu.s094758.shop.shopservice.Receipt"});
        }

        return messageTypeToJavaTypeMap.get(messageType);
    }
}
