package dk.dtu.s094758.shop.shopservice;

import javax.jws.WebService;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import dk.dtu.s094758.company.companyservice.CompanyService;
import dk.dtu.s094758.company.companyservice.Product;
import dk.dtu.s094758.company.companyservice.Customer;
import dk.dtu.s094758.postal.postalservice.Address;
import dk.dtu.s094758.postal.postalservice.Person;
import dk.dtu.s094758.postal.postalservice.PostalService;
import dk.dtu.s094758.shop.Client;
import dk.dtu.s094758.shop.Order;

/**
 *
 * @author linas
 */
@WebService()
public class Shop {

    @WebMethod(operationName = "orderProduct")
    public Receipt orderProduct(@WebParam(name = "client") Client client, @WebParam(name = "order") Order order) {

        // Validate Cutomer BEGIN
        // Information flow: Client -> Customer

        CompanyService companyService = new CompanyService();

        Customer customer = new Customer();

        String customerPersonalId = null;
        String customerFirstName = null;
        String customerLastName = null;

        try {
            customerPersonalId = client.getPersonalId();
            customerFirstName = client.getFirstName();
            customerLastName = client.getLastName();
        } catch (NullPointerException ex) {
        }

        try {
            customer.setPersonalId(customerPersonalId);
            customer.setFirstName(customerFirstName);
            customer.setLastName(customerLastName);
        } catch (NullPointerException ex) {
        }

        boolean isValidCustomer = companyService.getCompanyPort().validateCustomer(customer);

        // Validate Cutomer END


        // Validate Address BEGIN
        // Information flow: Client -> Address, Client -> Person

        PostalService postalService = new PostalService();

        Address address = new Address();

        String addressCity = null;
        String addressStreet = null;
        int addressStreetNumber = -1;

        try {
            addressCity = client.getCity();
            addressStreet = client.getStreet();
            addressStreetNumber = client.getStreetNumber();
        } catch (NullPointerException ex) {
        }

        try {
            address.setCity(addressCity);
            address.setStreet(addressStreet);
            address.setStreetNumber(addressStreetNumber);
        } catch (NullPointerException ex) {
        }

        Person person = new Person();

        String personFirstName = null;
        String personLastName = null;
        String personPersonalId = null;

        try {
            personFirstName = client.getFirstName();
            personLastName = client.getLastName();
            personPersonalId = client.getPersonalId();
        } catch (NullPointerException ex) {
        }

        try {
            person.setFirstName(personFirstName);
            person.setLastName(personLastName);
            person.setPersonalId(personPersonalId);
        } catch (NullPointerException ex) {
        }

        boolean isValidAddress = postalService.getPostalPort().validateAddress(address, person);

        // Validate Address END


        // Buy Product BEGIN
        // Information flow: Order -> Product

        Product product = new Product();

        String productName = null;
        int price = -1;

        try {
            productName = order.getProduct();
            price = order.getPrice();
        } catch (NullPointerException ex) {
        }

        try {
            product.setName(productName);
            product.setPrice(price);
        } catch (NullPointerException ex) {
        }

        boolean boughtProduct = false;

        boolean isValidAddress2 = isValidAddress;
        boolean isValidCustomer2 = isValidCustomer;

        if (isValidAddress2 && isValidCustomer2) {
            boughtProduct = companyService.getCompanyPort().buyProduct(product);
        }

        // Buy Product END


        // Receipt BEGIN

        Receipt receipt = new Receipt();

        String receiptPersonalId = null;
        String receiptFirstName = null;
        String receiptLastName = null;

        String receiptCity = null;
        String receiptStreet = null;
        int receiptStreetNumber = -1;

        String receiptProduct = null;
        int receiptPrice = -1;

        try {
            receiptPersonalId = customer.getPersonalId();
            receiptFirstName = customer.getFirstName();
            receiptLastName = customer.getLastName();

            receiptCity = address.getCity();
            receiptStreet = address.getStreet();
            receiptStreetNumber = address.getStreetNumber();

            receiptProduct = product.getName();
            receiptPrice = product.getPrice();
        } catch (NullPointerException ex) {
        }

        try {
            receipt.setPersonalId(receiptPersonalId);
            receipt.setFirstName(receiptFirstName);
            receipt.setLastName(receiptLastName);

            receipt.setCity(receiptCity);
            receipt.setStreet(receiptStreet);
            receipt.setStreetNumber(receiptStreetNumber);

            receipt.setProduct(receiptProduct);
            receipt.setPrice(receiptPrice);
        } catch (NullPointerException ex) {
        }

        // Receipt END

        return receipt;
    }
}
