package dk.dtu.s094758.pharmacy.pharmacyservice;

import javax.jws.WebService;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import dk.dtu.s094758.hospital.hospitalservice.HospitalService;
import dk.dtu.s094758.hospital.hospitalservice.Medication;
import dk.dtu.s094758.hospital.hospitalservice.Patient;
import dk.dtu.s094758.postal.postalservice.Address;
import dk.dtu.s094758.postal.postalservice.Person;
import dk.dtu.s094758.postal.postalservice.PostalService;

/**
 *
 * @author linas
 */
@WebService()
public class Pharmacy {

    @WebMethod(operationName = "orderMedication")
    public Receipt orderMedication(@WebParam(name = "personalIdParam") String personalIdParam, @WebParam(name = "drugParam") String drugParam) {

        HospitalService hospitalService = new HospitalService();
        PostalService postalService = new PostalService();

        Patient patient = hospitalService.getHospitalPort().getPatientById(personalIdParam);

        Address address = new Address();

        String city = null;
        String street = null;
        int streetNumber = -1;

        try {
            city = patient.getCity();
            street = patient.getStreet();
            streetNumber = patient.getStreetNumber();

        } catch (NullPointerException ex) {
        }

        String city2 = city;
        String street2 = street;
        int streetNumber2 = streetNumber;

        try {
           address.setCity(city2);
           address.setStreet(street2);
           address.setStreetNumber(streetNumber2);

        } catch (NullPointerException ex) {
        }

        Person person = new Person();

        String firstName = null;
        String lastName = null;
        String personalId = null;

        try {
            firstName = patient.getFirstName();
            lastName = patient.getLastName();
            personalId = patient.getPersonalId();

        } catch (NullPointerException ex) {
        }

        String firstName2 = firstName;
        String lastName2 = lastName;
        String personalId2 = personalId;

        try {
           person.setFirstName(firstName2);
           person.setLastName(lastName2);
           person.setPersonalId(personalId2);

        } catch (NullPointerException ex) {
        }

        boolean isValidAddress = postalService.getPostalPort().validateAddress(address, person);
        boolean isValidAddress2 = isValidAddress;

        Medication medication = null;

        if (isValidAddress2) {
            medication = hospitalService.getHospitalPort().buyMedication(drugParam);
        }

        Receipt receipt = new Receipt();

        String receiptPersonalId = null;
        String receiptFirstName = null;
        String receiptLastName = null;

        String receiptCity = null;
        String receiptStreet = null;
        int receiptStreetNumber = -1;

        String receiptDrug = null;
        int receiptPrice = -1;

        try {
           receiptPersonalId = patient.getPersonalId();
           receiptFirstName = patient.getFirstName();
           receiptLastName = patient.getLastName();

           receiptCity = address.getCity();
           receiptStreet = address.getStreet();
           receiptStreetNumber = address.getStreetNumber();

           receiptDrug = medication.getDrug();
           receiptPrice = medication.getPrice();

        } catch (NullPointerException ex) {
        }

        String receiptPersonalId2 = receiptPersonalId;
        String receiptFirstName2 = receiptFirstName;
        String receiptLastName2 = receiptLastName;

        String receiptCity2 = receiptCity;
        String receiptStreet2 = receiptStreet;
        int receiptStreetNumber2 = receiptStreetNumber;

        String receiptDrug2 = receiptDrug;
        int receiptPrice2 = receiptPrice;

        try {
           receipt.setPersonalId(receiptPersonalId2);
           receipt.setFirstName(receiptFirstName2);
           receipt.setLastName(receiptLastName2);

           receipt.setCity(receiptCity2);
           receipt.setStreet(receiptStreet2);
           receipt.setStreetNumber(receiptStreetNumber2);

           receipt.setDrug(receiptDrug2);
           receipt.setPrice(receiptPrice2);

        } catch (NullPointerException ex) {
        }

        return receipt;
    }
}
