package dk.dtu.imm.s094758.client;

import dk.dtu.ws1.service.classified.AccessCredentials;
import dk.dtu.ws1.service.classified.ClassificationException_Exception;
import dk.dtu.ws1.service.classified.ClassificationLevel;
import dk.dtu.ws1.service.classified.Customer;
import dk.dtu.ws1.service.classified.CustomerInformation;
import dk.dtu.ws1.service.classified.CustomerInformationService;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Hello world!
 *
 */
public class App {

    public static void main(String[] args) {

        AccessCredentials accessCredentials = new AccessCredentials();
        accessCredentials.setClassificationLevel(ClassificationLevel.LEVEL_3_SECRET);

        CustomerInformationService customerInformationService = new CustomerInformationService();
        CustomerInformation customerInformationPort = customerInformationService.getCustomerInformationPort();

        Customer customerInformation = null;
        try {
            customerInformation = customerInformationPort.getCustomerInformation("Jens", "Jørgensen", true, accessCredentials);
        } catch (ClassificationException_Exception ex) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
        }

        System.out.println(customerInformation.getFirstName());
        System.out.println(customerInformation.getLastName());
        System.out.println(customerInformation.getCprNummer());
        System.out.println(customerInformation.getCustomerNumber());
        System.out.println(customerInformation.getCustomerStatus());
        System.out.println(customerInformation.isIsActive());
        System.out.println(customerInformation.getAddress().getCountry());
        System.out.println(customerInformation.getAddress().getPostCode());
        System.out.println(customerInformation.getAddress().getCity());
        System.out.println(customerInformation.getAddress().getStreet());
        System.out.println(customerInformation.getAddress().getHouseNumber());
        System.out.println(customerInformation.getAddress().getRoomNumber());
    }
}
