package dk.dtu.ws1.mock;

import dk.dtu.s094758.lib.credentials.AccessCredentials;
import dk.dtu.s094758.lib.exception.ClassificationException;
import dk.dtu.s094758.lib.credentials.ClassificationLevel;
import dk.dtu.ws1.model.Customer;
import dk.dtu.ws1.service.classified.CustomerInformation;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author linas
 */
public class MockClient {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        CustomerInformation ci = new CustomerInformation();

        AccessCredentials accessCredentials = new AccessCredentials();
        accessCredentials.setClassificationLevel(ClassificationLevel.LEVEL_3_SECRET);

        Customer customerInformation = null;
        try {
            customerInformation = ci.getCustomerInformation("Jens", "Jørgensen", true, accessCredentials);
        } catch (ClassificationException ex) {
            Logger.getLogger(MockClient.class.getName()).log(Level.SEVERE, null, ex);
        }

        System.out.println(customerInformation.getFirstName());
        System.out.println(customerInformation.getLastName());
        System.out.println(customerInformation.getSocialSecurityNumber());
        System.out.println(customerInformation.getCustomerNumber());
        System.out.println(customerInformation.getCustomerStatus());
        System.out.println(customerInformation.getIsActive());

        if (customerInformation.getAddress() != null) {

            System.out.println(customerInformation.getAddress().getCountry());
            System.out.println(customerInformation.getAddress().getPostCode());
            System.out.println(customerInformation.getAddress().getCity());
            System.out.println(customerInformation.getAddress().getStreet());
            System.out.println(customerInformation.getAddress().getHouseNumber());
            System.out.println(customerInformation.getAddress().getRoomNumber());
        }
    }
}
