package dk.dtu.ws1.service;

import dk.dtu.s094758.lib.credentials.ClassificationLevel;
import dk.dtu.s094758.lib.annotation.ClassifiedWebMethod;
import dk.dtu.s094758.lib.annotation.ClassifiedWebService;
import dk.dtu.ws1.model.Address;
import dk.dtu.ws1.model.Customer;
import dk.dtu.ws1.model.CustomerStatus;

/**
 *
 * @author linas
 */
@ClassifiedWebService()
public class CustomerInformation {

    /**
     * Web service operation
     */
    @ClassifiedWebMethod(operationName = "getCustomerInformation", classificationLevel=ClassificationLevel.LEVEL_2_CONFIDENTIAL)
    public Customer getCustomerInformation(String firstName, String lastName, Boolean isActive) {

        Address address = new Address();
        address.setCountry("Danmark");
        address.setCity("Brønshøj");
        address.setStreet("Terrasserne");
        address.setHouseNumber(12);
        address.setRoomNumber(25);
        address.setPostCode(2700);

        Customer customer = new Customer();
        customer.setFirstName(firstName);
        customer.setLastName(lastName);
        customer.setSocialSecurityNumber("120185-3445");
        customer.setCustomerNumber(1234567);
        customer.setCustomerStatus(CustomerStatus.GOLD);
        customer.setIsActive(isActive);
        customer.setAddress(address);

        return customer;
    }
}
